#include <iostream>

using namespace std;

int pass_by_value(int p)
{
  ++p;
  return p;
}

int pass_by_pointer(int* p)
{
  ++(*p);
  return *p;
}

int pass_by_reference(int& p)
{
  ++p;
  return p;
}

void create_on_pointer(int* p)
{
  p = new int(42);
}

void create_on_reference(int*& p)
{
  p = new int(42);
}

int main()
{
  int a = 42;
  int r;
  
  cout << "Pass by value" << endl;
  r = pass_by_value(a);
  cout << "a = " << a << ", r = " << r << endl;  
  
  cout << "Pass by pointer" << endl;
  r = pass_by_pointer(&a);
  cout << "a = " << a << ", r = " << r << endl;
  
  cout << "Pass by reference" << endl;
  r = pass_by_reference(a);
  cout << "a = " << a << ", r = " << r << endl;
  
  
  int *q = new int(0);  
  cout << "Create on pointer" << endl;
  cout << "Before: q = " << q << ", *q = " << *q << endl;
  create_on_pointer(q);
  cout << "After: q = " << q << ", *q = " << *q << endl;
  delete q;
  
  q = new int(0);  
  cout << "Create on reference" << endl;
  cout << "Before: q = " << q << ", *q = " << *q << endl;
  create_on_reference(q);
  cout << "After: q = " << q << ", *q = " << *q << endl;
  delete q;
  // Krds: van memria szivrgs?
  
  return 0;
}
