#include <iostream>

using namespace std;

int return_by_value()
{
  int x = 42;
  return x;
}

int* return_by_pointer_local()
{
  int x = 42;
  return &x;
}

int* return_by_pointer_param(int* p)
{
  *p = 42;
  return p;
}

int* return_by_pointer_heap()
{
  int* x = new int(42);
  return x;
}

int& return_by_reference_local()
{
  int x = 42;
  return x;
}

int& return_by_reference_param(int& p)
{
  p = 42;
  return p;
}

int main()
{
  int a, b;
  int* q;
  
  cout << "Return by value" << endl;
  a = return_by_value();
  cout << "a = " << a << endl;
  
  cout << "Return by pointer (local)" << endl;
  q = return_by_pointer_local();
  //a = *q; // Undefined behaviour (possible segfault)
  //cout << "a = " << a << endl;
  
  cout << "Return by pointer (param)" << endl;
  a = 0;
  q = return_by_pointer_param(&a);
  b = *q;
  cout << "a = " << a << ", b = " << b << endl;
  ++(*q);
  cout << "a = " << a << ", b = " << b << endl;
  
  cout << "Return by pointer (heap)" << endl;
  q = return_by_pointer_heap();
  a = *q;
  cout << "a = " << a << endl;
  delete q;
  
  cout << "Return by reference (local)" << endl;
  //int& r = return_by_reference_local(); // Undefined behaviour (possible segfault)
  //cout << "a = " << a << ", r = " << r << endl;
  
  cout << "Return by reference (param)" << endl;
  a = 0;
  int& s = return_by_reference_param(a);
  cout << "a = " << a << ", s = " << s << endl;
  ++s;
  cout << "a = " << a << ", s = " << s << endl;
  
  return 0;
}